/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: uart.c 7735 2013-08-05 01:41:22Z yeom $
 */

/*
 *		ꥢI/OǥХSIO˥ɥ饤СUARTѡ
 */

#include "Os.h"
#include "target_serial.h"

/* ؿΥץȥ */
LOCAL_INLINE boolean uart_getready(CoreIdType coreid);
LOCAL_INLINE uint8 uart_getchar(CoreIdType coreid);

/*
 *  ʸå
 */
LOCAL_INLINE boolean
uart_getready(CoreIdType coreid)
{
	uint32 base = target_fput_log_base_table[coreid];
	return((sil_rew_iop((void *) (base + UART_STATUS_OFFSET)) & UART_STATUS_RRDY) != 0U);
}

/*
 *  ʸμФ
 */
LOCAL_INLINE uint8
uart_getchar(CoreIdType coreid)
{
	uint32 base = target_fput_log_base_table[coreid];
	return((uint8) sil_rew_iop((void *) (base + UART_RXDATA_OFFSET)));
}

/*
 *  
 */
void
InitHwSerial(void)
{
	uint32 base = target_fput_log_base_table[x_core_id()];

	/*
	 *  ܡ졼Ȥ
	 */
	uart_set_baudrate(base);

	/*
	 *  ߵ
	 */
	sil_wrw_iop((void *) (base + UART_CONTROL_OFFSET),
				sil_rew_iop((void *) (base + UART_CONTROL_OFFSET))
				| UART_CONTROL_IRRDY);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
TermHwSerial(void)
{
	uint32 base = target_fput_log_base_table[x_core_id()];
	/*
	 * ߤζػ
	 */
	sil_wrw_iop((void *) (base + UART_CONTROL_OFFSET),
				sil_rew_iop((void *) (base + UART_CONTROL_OFFSET))
				& (~UART_CONTROL_IRRDY));
}

LOCAL_INLINE void
RxHwSerialInt_handler(CoreIdType coreid)
{
	if (uart_getready(coreid) != FALSE) {
		/*
		 *  ΥХå롼ƤӽФ
		 */
		RxSerialInt(uart_getchar(coreid));
	}
}


/*
 *  SIOγߥϥɥ
 */
ISR(RxHwSerialInt0)
{
	RxHwSerialInt_handler(0U);
}

ISR(RxHwSerialInt1)
{
	RxHwSerialInt_handler(1U);
}
