/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_config.c 7933 2013-10-02 10:59:02Z shigihara $
 */

/*
 *		åȰ¸⥸塼NIOS2_DEVѡ
 */

#include "kernel_impl.h"
#include "mc.h"
#include "nios2_gcc/prc_sil.h"
#include "target_sysmod.h"
#include "target_ici.h"
#ifdef ENABLE_RETURN_MAIN
#include "interrupt.h"
#endif /* ENABLE_RETURN_MAIN */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

#ifdef USE_UART
#include "nios2_gcc/uart.h"

/*
 *  UARTΥ١ɥ쥹
 */
const uint32	target_fput_log_base_table[TotalNumberOfCores] = {
	UART_PORT0_BASE,
#if TotalNumberOfCores > 1
	UART_PORT1_BASE,
#endif /* TotalNumberOfCores > 1 */
#if TotalNumberOfCores > 2
	UART_PORT2_BASE,
#endif /* TotalNumberOfCores > 2 */
#if TotalNumberOfCores > 3
	UART_PORT3_BASE,
#endif /* TotalNumberOfCores > 3 */
};

#else /* USE_UART */
#include "nios2_gcc/jtag_uart.h"

/*
 *  JTAG UARTΥ١ɥ쥹
 */
const uint32	target_fput_log_base_table[TotalNumberOfCores] = {
	JTAG_UART_PORT0_BASE,
#if TotalNumberOfCores > 1
	JTAG_UART_PORT1_BASE,
#endif /* TotalNumberOfCores > 1 */
#if TotalNumberOfCores > 2
	JTAG_UART_PORT2_BASE,
#endif /* TotalNumberOfCores > 2 */
#if TotalNumberOfCores > 3
	JTAG_UART_PORT3_BASE,
#endif /* TotalNumberOfCores > 3 */
};

#endif /* USE_UART */

/* ؿΥץȥ */
static void hw_version_check(void);

/*
 *  ֳֹ
 */
const InterruptNumberType
target_ici_intno_table[TotalNumberOfCores] = {
	INTNO_ICI0,
#if TotalNumberOfCores > 1
	INTNO_ICI1,
#endif /* TotalNumberOfCores > 1 */
#if TotalNumberOfCores > 2
	INTNO_ICI2,
#endif /* TotalNumberOfCores > 2 */
#if TotalNumberOfCores > 3
	INTNO_ICI3,
#endif /* TotalNumberOfCores > 3 */
};

/*
 *  ֳͥ
 */
const PriorityType
target_ici_intpri_table[TotalNumberOfCores] = {
	-(INTPRI_ICI0),
#if TotalNumberOfCores > 1
	-(INTPRI_ICI1),
#endif /* TotalNumberOfCores > 1 */
#if TotalNumberOfCores > 2
	-(INTPRI_ICI2),
#endif /* TotalNumberOfCores > 2 */
#if TotalNumberOfCores > 3
	-(INTPRI_ICI3),
#endif /* TotalNumberOfCores > 3 */
};

/*
 *  ֳHWΥ١ɥ쥹
 */
const uint32	target_core_int_base_table[TotalNumberOfCores] = {
	CORE_INT_0_BASE,
#if TotalNumberOfCores > 1
	CORE_INT_1_BASE,
#endif /*TotalsNumberOfCores > 1 */
#if TotalNumberOfCores > 2
	CORE_INT_2_BASE,
#endif /* TotalNumberOfCores > 2 */
#if TotalNumberOfCores > 3
	CORE_INT_3_BASE,
#endif /* TotalNumberOfCores > 3 */
};


#if TTYPE_KLOCK == C_KLOCK

/*
 *  åΥơ֥
 */
const uint32	target_tsk_lock_table[TotalNumberOfCores] = {
	TSK_MUTEX_0_BASE,
#if TotalNumberOfCores > 1
	TSK_MUTEX_1_BASE,
#endif /* TotalNumberOfCores > 1 */
#if TotalNumberOfCores > 2
	TSK_MUTEX_2_BASE,
#endif /* TotalNumberOfCores > 2 */
#if TotalNumberOfCores > 3
	TSK_MUTEX_3_BASE,
#endif /* TotalNumberOfCores > 3 */
};

/*
 *  󥿥åΥơ֥
 */
const uint32	target_cnt_lock_table[TotalNumberOfCores] = {
	CNT_MUTEX_0_BASE,
#if TotalNumberOfCores > 1
	CNT_MUTEX_1_BASE,
#endif /* TotalNumberOfCores > 1 */
#if TotalNumberOfCores > 2
	CNT_MUTEX_2_BASE,
#endif /* TotalNumberOfCores > 2 */
#if TotalNumberOfCores > 3
	CNT_MUTEX_3_BASE,
#endif /* TotalNumberOfCores > 3 */
};

#endif /* TTYPE_KLOCK == C_KLOCK */

/*
 *  ʸν
 */
void
target_fput_str(const char8 *c)
{
	while (*c != '\0') {
		nios2_dev_putc(*c);
		c++;
	}
	nios2_dev_putc('\n');
}

/*
 *  Сå
 */
static void
hw_version_check(void)
{
	/* ǧ */
	if (sil_rew_iop((void *) (SYSVER_NUM_CORE)) != TNUM_HWCORE) {
		target_fput_str("Number of core is mismatch!!");
		while (1) {
		}
	}

	if (sil_rew_iop((void *) (SYSVER_MAJOR_VAR)) != MAJOR_VAR) {
		target_fput_str("Hardware Major version is mismatch!!");
		while (1) {
		}
	}
}
void
target_hardware_initialize(void)
{
	/*
	 *  ϡɥСγǧ
	 */
	hw_version_check();

	prc_hardware_initialize();
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	CoreIdType coreid = x_core_id();

	/*
	 *  Nios2¸ν
	 */
	prc_initialize();

#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼ǽν
	 */
	trace_initialize((uintptr) (TRACE_AUTOSTOP));
#endif /* TOPPERS_ENABLE_TRACE */

	x_config_int(GET_ICI_INTNO(coreid), ENABLE, GET_ICI_INTPRI(coreid));
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
#ifdef ENABLE_RETURN_MAIN
	CCB	*p_ccb = get_my_p_ccb();
#endif /* ENABLE_RETURN_MAIN */

#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼Υ
	 */
	trace_dump(&target_fput_log);
#endif /* TOPPERS_ENABLE_TRACE */

#ifndef ENABLE_RETURN_MAIN
	/*
	 *  åȥν
	 */
	target_fput_str("Kernel Exit...");
#else
	target_fput_str("Kernel Shutdown...");
#endif /* ENABLE_RETURN_MAIN */

	/*
	 *  Nios2¸νλ
	 */
	prc_terminate();

#ifdef ENABLE_RETURN_MAIN
	p_ccb->kerflg = FALSE;
	p_ccb->sus_all_cnt = 0U;
	p_ccb->sus_all_cnt_ctx = 0U;
	p_ccb->sus_os_cnt = 0U;
	p_ccb->sus_os_cnt_ctx = 0U;
	p_ccb->target_ccb.except_nest_cnt = 0U;
	p_ccb->target_ccb.nested_lock_os_int_cnt = 0U;

	/* λΤƱ */
	barrier_sync(5U, FALSE);

	/* OSå᤹ */
	Asm("rdctl r3, cpuid");
	Asm("srli  r3, r3, 20");
	Asm("subi  r3, r3, 0x20");
	Asm("slli  r3, r3, 2");
	Asm("movhi r4, %hiadj(_ostkpt_table)");
	Asm("addi  r4, r4, %lo(_ostkpt_table)");
	Asm("add   r2, r4, r3");
	Asm("ldw   sp, 0(r2)");

	/* ޥϵư֤Τޤmainؿ */
	if (x_core_id() == OS_CORE_ID_MASTER) {
		/* ưƤOSΥ1᤹ */
		activated_cores = 1U;
		Asm("call  main");
	}
	else {
		/*
		 * 졼֥ϼΥޥStartCore
		 * ưޤ̵¥롼פԵ(slave_start)
		 */
		while (is_halt(x_core_id())) {
		}
		;
		Asm("call main");
	}
#endif /* ENABLE_RETURN_MAIN */

	while (1) {
	}
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char8 c)
{
	nios2_dev_putc(c);
}

/*
 *	ֳߤμ
 */
ISR(target_ici_handler0)
{
	ici_handler_main();
}
#if TotalNumberOfCores > 1
ISR(target_ici_handler1)
{
	ici_handler_main();
}
#endif /* TotalNumberOfCores > 1 */
#if TotalNumberOfCores > 2
ISR(target_ici_handler2)
{
	ici_handler_main();
}
#endif /* TotalNumberOfCores > 2 */
#if TotalNumberOfCores > 3
ISR(target_ici_handler3)
{
	ici_handler_main();
}
#endif /* TotalNumberOfCores > 3 */
